music('deepsparse.ogg')
box1=huwalls([(450, 500), (700, 500), (700, 0), (350+26, 0), 'box1in',
            (350-26, 0), (0, 0), (0, 500), (250, 500)],
           pos=(0, 900), counter=True, closed=False,
           bg=("level4-room1", -1, -1))
b1idoor = door(box1, 'box1in')
startpattern = [((0, 10), 90), ((0, 0), -1), 'delete(self,"bottom")',
                'b1idoor.open()']
p = Player(pos=(100, 100), angle=270)
startbox = package(payload=p, pattern=startpattern,
                   rel=('top', box1), pos=(350-26, -900), texture="humanboxwall", bg='humanboxbg')
circle(20, pos=(350, 1150), static=True, image="anchor")
box1p2 = deinwalls([(450, 500), 'box1out', (250, 500)], rel=box1)
b1odoor = door(box1p2, 'box1out')
s = switch(shapes=[Circle(8, image="human-button", under=True)], pos=(250, 1400), action=['b1odoor.open()', 'set_flag("switch1", True)'], angle=90)

crushbox = huwalls([(600, 0), 'indoor', (400, 0), (0,0), (0, 400), (400, 400)],
                   counter=True, rel=('bottom', box1), pos=(-150, 0),
                   bg=('level4-room2', -2, -1),
                   corners_at=[(-2, 'end', ('invertcorner', 270))])
door(crushbox, 'indoor', use_startcorner=False).open()

crushrighttopwall = huwalls((600, -THICKNESS), (600, 200-THICKNESS),
                          rel=crushbox, use_first_start=False, use_last_end=False)
crushrightinswall = deinwalls((600, 200), (200, 200), rel=crushbox,
                              use_startcorner=False, use_first_start=False)
crushinsidewall = deinwalls((600, 200+THICKNESS), (600, 600),
                            rel=crushbox, use_first_start=False,
                            startcorner='humandoublewall-corner')
# We'll open this door later
crushopendoor = huwalls((600, 600), 'door', (600, 800), rel=crushbox)

downpat = [((0, 5), 40), ((0, 0), 0), ((0, -5), 40), ((0, 0), 0), Repeat]
uppat = mirror_y(downpat)

topcrush = deinwalls([(0, 0), (200, 0)], pattern=downpat, rel=crushbox)
botcrush = deinwalls([(0, 400), (200, 400)], counter=True, pattern=uppat, rel=crushbox)

topcrush2 = deinwalls([(0, 0), (200, 0)], pattern=[((0, 5), 20), ((0, 0), 0), ((0, -5), 40), ((0, 0), 0), ((0, 5), 20), Repeat],
                      rel=crushbox, pos=(200, 100))

tunnelargs = {'rel':crushbox, 'pos':(400, 400), 'use_first_start':False}
#tunnelright = huwalls([(200, 0), (200, 200)], **tunnelargs)
tunnelleft = huwalls([(200, 400), (0, 400), (0, 0)], bg='level4-hall', **tunnelargs)

room2 = huwalls([(0, 0), (800, 0), (800, 600), 'room2out', (700, 600),
                 (0, 600)],
                rel=[('right', tunnelleft), ('bottom', tunnelleft, 'bottom')],
                pos=(0, 0), bg=('trainingbg2', -1, -1), use_last_end=False,
                )

door(crushopendoor, 'door').open()
e1ai = ai.Leads(period=40, turnspeed=1, strength=40)
e1 = enemy(ai=ai.Stationary(),
          shapes=[Circle(8, image="drone")], pos=(28, 300), rel=room2,
          size=8, health=None, static=True, angle=270)

shelter = deinwalls([(200, 300), (200, 200), (300, 200), (300, 300)],
                rel=room2)

shelter2 = inwalls([(520, 600), (520, 400)], rel=room2, use_endcorner=False,
                   corners_at=[(-1, 'end', 'end')])


room3 = huwalls([(100, 0), (100, 100), (0, 100), (0, 400), (300, 400),
               (300, 100), (200, 100), (200, 0)],
                rel=room2, pos=(600, 600), counter=True,
                bg=("level4-bottle", -1, -1),
                corners_at=[(-1, 'end', ('invertcorner', 180))],
                use_first_start=False)

r2odoor = door(room2, 'room2out', use_startcorner=False,
               texture='humandoublewall', start=('humandoublewall-end', 0))

s2 = switch(shapes=[Circle(8, image="human-button", under=True)], pos=(800, 400), rel=room2, action=['r2odoor.open()'], angle=180)

e2dist = 600-24
e2ai=ai.Shoots()
e2 = enemy(ai=ai.Stationary(), shapes=[Circle(8, image="drone")], pos=(500, 12),
           rel=room2, angle=180, static=True, health=None,
           pattern=[((0, e2dist/72), 72), ((0, -e2dist/72), 72), Repeat])

dialog("The pull beam can be used for more than just moving other things around.", characters.Lisa)
dialog("It's like a rope made of pure energy, totally unbreakable, and easily capable of handling the mass of your ship.", characters.Lisa)
dialog("If you anchor it to something that's much heavier than you, or is stationary - like a wall - you can swing around and change your direction quickly.", characters.Lisa)
dialog("Play around with it this room, and get used to it - it will be invaluable for maneuvering in the tight spots you'll be headed for.", characters.Lisa)
dialog("Fire the pull-beam with the '%s' key. Release it by pressing '%s' again." % (get_control('shoot_hook'), get_control('shoot_hook')))
dialog("Reel in pull-beam with the '%s' key. Reel it out by pressing '%s'." % (get_control('reel_in'), get_control('reel_out')))
dialog("There's a switch on the south wall. Hit it when you're ready to move on.", characters.Lisa)
flag('switch1')
ds = Sequence(Dialog("Getting past this crusher is tough, but the pull beam should help.", characters.Lisa))
objectin(p, (0, 0, 200, 400), rel=tunnelleft, meanwhile=ds)
e1.ai = e1ai
e2.ai = e2ai

objectin(p, (0, 100, 300, 300), rel=room3, meanwhile=Sequence(
    Dialog("Now just zip through this last room.", characters.Lisa)))
    
dialog("Nice going. We'll make a real pilot out of you yet.", characters.Lisa)
nextlevel="level5"
