import os.path
configfile = os.path.expanduser('~/.alexandriarc')
if configfile.startswith('~/'): # We're running on Windows..
    configfile = configfile.replace('~/.', './')
broken = False

STARTLEVEL = ('training', 'level1')
#STARTLEVEL = ('healbeam', 'station-broken')

CONFIG_DEFAULTS = {'solved': {},
                   'unlocked': { 'training': ['level1'] },
                   'resolution': (800, 600),
                   'version':1,
                   'nextlevel': STARTLEVEL,
                   'layout': 'qwerty',
                   'bindings': {},
                   'musicvolume': 1.0, 'fxvolume': 1.0,
                   'showfps': False}

# In case STARTLEVEL isn't training/level1, unlock it.
CONFIG_DEFAULTS['unlocked'].setdefault(STARTLEVEL[0], []).append(STARTLEVEL[1])

class ConfigManager(object):
    def __init__(self):
        super(ConfigManager, self).__init__()
        self.load_config()
        self.manager = None #But will get set from outside!

    def load_config(self):
        g = {'__builtins__':{}, 'True':True, 'False':False}
        g.update(CONFIG_DEFAULTS)
        try:
            execfile(configfile, g)
        except IOError:
            pass #Who cares
        for attr in CONFIG_DEFAULTS:
            setattr(self, attr, g[attr])

        #print g

    def save_config(self):
        f = file(configfile, 'w')
        for attr in CONFIG_DEFAULTS:
            str = '%s = %s\n' %(attr, repr(getattr(self, attr)))
            f.write(str)
        #print self.solved, self.resolution

Config = ConfigManager()
