import pygame
               
class TitleView(object):
    PERIOD = 30
    '''A View that doesn't actually view anything, but displays a title screen.

    '''
    def __init__(self):
        self.font = pygame.font.Font("freesansbold.ttf", 24)
        self.text = self.font.render('Press a key to start', True, (255, 255, 255))
        self.textrect = self.text.get_rect()
        self.screen = pygame.display.get_surface()
        screenrect = self.screen.get_rect()
        self.textrect.centerx = screenrect.centerx
        self.textrect.midbottom = screenrect.midbottom
        self.textrect.bottom -= 40
        self.i = 0

    def draw(self):
        self.screen.fill((0, 0, 0))

        if int(self.i / self.PERIOD) % 2:
            self.screen.blit(self.text, self.textrect)

        pygame.display.flip()

    def thread(self):
        while True:
            yield None
            self.draw()
            self.i += 1
